<?
/**
 * @mainpage
 *
 * %PKIX ASN1 package for PHP provides classes for manipulating several
 * %PKIX types of messages.
 *
 * @section Features
 *
 * - parsing ASN.1 messages
 * - creating ASN.1 messages from PHP data
 * - exchanging ASN.1 messages over HTTP (both in client and server
 *   role)
 *
 * @section prereqs Dependencies
 *
 * - PHP 5.3 with openssl and bcmath support
 * - PHP-ASN1 library (based on the work of Adam Pippin (GP, Inc.))
 *
 * @section Supported Messages
 *
 * - OCSP (RFC2560, RFC5019) \link PKIX::OCSP::Request request
 *    \endlink and \link PKIX::OCSP::Response response\endlink

 * - TSP (RFC3161) \link PKIX::TSP::Request request\endlink and \link
 *     PKIX::TSP::Response response\endlink
 */

?>